package main

import (
	"context"

	"github.com/jackc/pgx/v5"
)

var dbConn *pgx.Conn

func InitDatabase(ctx context.Context) {
	conn, err := pgx.Connect(ctx, "postgres://master:secret@localhost:5432")
	if err != nil {
		panic(err)
	}

	_, err = conn.Exec(ctx, `
		CREATE TABLE IF NOT EXISTS users (
		    id SERIAL PRIMARY KEY,
		    name VARCHAR(20) UNIQUE NOT NULL,
		    pass_hash VARCHAR(60) NOT NULL,
		    pronouns VARCHAR(15) DEFAULT NULL,
		    color VARCHAR(3) DEFAULT NULL
		);
		CREATE TABLE IF NOT EXISTS chat_groups (
		    id SERIAL PRIMARY KEY,
		    name VARCHAR(48) NOT NULL,
		    creator_id INTEGER NOT NULL REFERENCES users(id) ON DELETE CASCADE,
		    owner_id INTEGER NOT NULL REFERENCES users(id) ON DELETE CASCADE,
		    enable_user_colors BOOLEAN NOT NULL DEFAULT true,
		    group_color VARCHAR(3),
		    created_at TIMESTAMP NOT NULL DEFAULT NOW()
		);
		CREATE TABLE IF NOT EXISTS chat_group_members (
			group_id INTEGER NOT NULL REFERENCES chat_groups(id) ON DELETE CASCADE,
			user_id  INTEGER NOT NULL REFERENCES users(id) ON DELETE CASCADE,
			joined_at TIMESTAMP NOT NULL DEFAULT NOW(),
			PRIMARY KEY (group_id, user_id)
		);
	`)
	if err != nil {
		panic(err)
	}

	dbConn = conn
}

func DbSaveClientWithoutGroups(ctx context.Context, client *Client) error {
	var id uint64
	var err error

	err = dbConn.QueryRow(ctx, `
        INSERT INTO users (name, pass_hash, pronouns)
        VALUES ($1, $2, $3)
        RETURNING id
    `, client.Name, client.PasswordHash, client.Pronouns).Scan(&id)
	return err
}

func DbGetClient(ctx context.Context, id uint32, client *Client) error {
	err := dbConn.QueryRow(ctx, `
			SELECT name, pass_hash, pronouns, color WHERE id =  $1
		`, id).Scan(client.Name, client.PasswordHash, client.Pronouns, client.Color)
	if err != nil {
		return err
	}
	return nil
}
